#include "main.h"
#include "string.h"
//------------------------------------------------
unsigned char bt, tmp;
//------------------------------------------------
void interrupt isr(void)
{
  if(RCIF)
  {
    if(FERR)
    {
      tmp = RCREG;
      return;
    }
    else if (OERR)
    {
      CREN = 0;      
      CREN = 1;
      return;
    }
    bt=RCREG;
    PORTB=bt;
  }
}
//------------------------------------------------
void USART_Transmit(unsigned char tx_byte)
{
  while(!TRMT) ;
  TXREG=tx_byte;
}
//------------------------------------------------
void USART_Transmit_Arr(unsigned char *tx_buff, unsigned int tx_len)
{
  unsigned int cnt=0;
  while(cnt<tx_len)
  {
    USART_Transmit(tx_buff[cnt]);
    cnt++;
  }
}
//------------------------------------------------
void USART_Transmit_Str(char *str_buff)
{
  unsigned int cnt=0;
  unsigned int tx_len = strlen(str_buff);
  while(cnt<tx_len)
  {
    USART_Transmit(str_buff[cnt]);
    cnt++;
  }
}
//------------------------------------------------
void main()
{
  char str1[15];
  int i;
  TRISB=0X00;
  PORTB=0X00;
  TRISC6 = 1; //USART (TX);
  TRISC7 = 1; //USART (RX);
  SPBRG=12;//19200
  TX9  = 0;
  TXEN = 1;
  SYNC = 0;
  BRGH = 1;
  TX9D = 0;
  RX9  = 0;
  CREN = 1;
  RX9D = 0;
  RCIE=1;
  GIE=1;
  PEIE=1;
  SPEN = 1;
  while(1)
  {
    for(i=0;i<256;i++)
    {
      //TXREG=i;
      USART_Transmit(i);
      //USART_Transmit_Arr("1234567890\r\n",12);
      //USART_Transmit_Str("1234567890\r\n");
      //sprintf(str1,"String%03d\r\n",i);
      //USART_Transmit_Str(str1);
      __delay_ms(105);
    }
  }
}
//------------------------------------------------
